(defun init-stzfund ()
	(setq dOK (koecher.get Aufl_ID delta_V))		
	(print dOK)	; vertikale Verschiebung
	
	(if (= (Connect.get CastaData LinkesEnde) 1)
		(progn
			(setq TrgEnde (Traeger.get Tr_ID links))
		)
	)
	(if (= (Connect.get CastaData RechtesEnde) 1)
		(progn
			(setq TrgEnde (Traeger.get Tr_ID rechts))
		)
	)
	
;	(TrEnde.set TrgEnde (delta_l (- dOK)))
	;; gendert 2008-09-23 - AF  
	;;          2008-10-13 - AF
	;; Ende trimmen muss nach der Winkelzuweisung erfolgen,
	;; deswegen zuletzte nderung in Funktion init-traegerende verlegt
	;; funktionierte nur bei 90 Enden, nicht bei schrgen Sttzen
	;; fiel nur auf, wenn Fundament vertikal versetzt angeordnet wurde
)

(defun init-traegerende ()
	(print ">-----------------------------------------------------------")
	(print "BERECHNE TRAEGERENDE")
	(if (= (Connect.get CastaData LinkesEnde) 1)
		(setq AtEnde (Traeger.get Tr_ID links))
	)
	(if (= (Connect.get CastaData RechtesEnde) 1)
		(setq AtEnde (Traeger.get Tr_ID rechts))
	)
	
	(setq r_winkel_at	(Traeger.get Tr_ID r_winkel))
	(print r_winkel_at)
	
	(setq vwinkel_at_glob (Connect.get CastaData trg_vwinkel))
	(setq hwinkel_at_glob (Connect.get CastaData trg_hwinkel))
	(print vwinkel_at_glob)
	(print hwinkel_at_glob)
	
	(setq afl_vwinkel (Connect.get CastaData afl_vwinkel))
	(setq afl_hwinkel (Connect.get CastaData afl_hwinkel))
	(print afl_vwinkel)
	(print afl_hwinkel)
	
	
	
	(if (= r_winkel_at 0.0)
		(progn
			(setq v_endWinkel (- 180.0 vwinkel_at_glob))
			(setq h_endWinkel 0)
		)
	)
	
	(if (= r_winkel_at 90.0)
		(progn
			(setq v_endWinkel 0)
			(setq h_endWinkel vwinkel_at_glob)
		)
	)			
	
	(if (= r_winkel_at 180.0)
		(progn
			(setq v_endWinkel vwinkel_at_glob)
			(setq h_endWinkel 0)
		)
	)
	
	(if (= r_winkel_at 270.0)
		(progn
			(setq v_endWinkel 0)
			(setq h_endWinkel (- 180.0 vwinkel_at_glob))
		)
	)
	
	(if (= (Connect.get CastaData trg_vwinkel) 90.0)
		(progn
			(setq v_endWinkel 0)
			(setq h_endWinkel 0)	
		)
	)	
	(if (= (Connect.get CastaData trg_vwinkel) 270.0)
		(progn
			(setq v_endWinkel 0)
			(setq h_endWinkel 0)	
		)
	)	
	
	(print v_endWinkel)
	(print h_endWinkel)
	
	(TrEnde.set AtEnde	(v_winkel v_endWinkel)
				(h_winkel h_endwinkel)
	)
	(print "------------------------------------------------------------")

	(print "-------------------- Nachlauf Trgerende krzen ------------")
	;;          2008-10-13 - AF
	;; pTrim-Funktion bedarf zuvor eingestelltem TrgerendeWinkel
	;; dies erfolgt erst in dieser Funktion - deswegen der Nachlauf hier ...
	(TrEnde.set AtEnde (delta_l 0))
	(TrEnde.pTrim AtEnde (- dOK))
	(setq	deltaV (Traeger.get Tr_ID delta_V)
		deltaH (Traeger.get Tr_ID delta_LR)
		VWinkel (TrEnde.get AtEnde V_Winkel)
		HWinkel (TrEnde.get AtEnde H_Winkel)
	)

	; Korrektur Nov. 2011
	(if (= (Connect.get CastaData RechtesEnde) 1) (setq deltaV (- deltaV)))

	(print HWinkel)
	(setq WarnFlag 0)
	(if (/= deltaH 0.0) (progn
	    (setq sinW    (sin (* PI (/ (- HWinkel 90.0) 180))))
	    (TrEnde.pTrim AtEnde (* sinW deltaH))
	    (if (/= sinW 0.0) (setq WarnFlag (+ WarnFlag 1)))
	))
	(if (/= deltaV 0.0) (progn
	    (setq sinW    (sin (* PI (/ (- VWinkel 90.0) 180))))
	    (TrEnde.pTrim AtEnde (* sinW deltaV))
	    (if (/= sinW 0.0) (setq WarnFlag (+ WarnFlag 1)))
	))
	(if (>= WarnFlag 2) (achtung_H_V_Problem))
	(print "------------------------------------------------------------")

)
(defun achtung_H_V_Problem ()
   (alertBox "
 Achtung!\n
 Es liegen sowohl Winkel in H und V-Richtung vor als auch\n
 Verschiebungen. Diese knnen vom Anschlussmakro nicht gleichzeitig\n
 bearbeitet werden."  "WRN_HV_Angle_and_Offsets"
   )
)
