(defun load-modules ()
	; Profil prfen
	(setq qsform_at (Traeger.get Tr_ID qsform))
  (print qsform_at)
  
  (if (= qsform_at "L")	(load "mod-calc-windverband_L"))
  (if (= qsform_at "F")	(load "mod-calc-windverband_F"))
  (if (= qsform_at "U") (alertBox "Anschluss noch nicht mglich."  "Connection_Not_Possible_Yet"));
  (if (= qsform_at "I") (alertBox "Anschluss noch nicht mglich."  "Connection_Not_Possible_Yet"));
  (if (= qsform_at "R") (alertBox "Anschluss noch nicht mglich."  "Connection_Not_Possible_Yet"));
  (if (= qsform_at "K") (alertBox "Anschluss noch nicht mglich."  "Connection_Not_Possible_Yet"));
)

(defun init-connection ()
	(print "********************************************************************")
  (print "in init-connection - stz_Windverb_mit Rundstahl");
   
  (connect.ShowAttributes CastaData)
 
  ; Tr_ID ist der Verbandsstab
  ; HTrg  ist die Sttze, an die angeschlossen wird
  
  (setq l_schr 200)
  (setq parallel_abstand_stz 30)
  (setq rand_abst 10)
	
;	(init-windverband)

  (print "Beispiel fr Erzeugung Augenblech")
  
    ; Blechobjekt erzeugen
  (setq augBlech_Links (Blech.create))

    ; Wenn das Objekt als Augenblech angefgt wird, werden dp, hp und bp neu gesetzt
    ; Zudem werden die beiden Attribute fr den Schlitz gesetzt:
    ; lSchlitz und dSchlitz. Sollen also andere Werte gelten, dann muss man
    ; diese nach dem addAbtl setzen. (Zumindest momentan)
  (traeger.addabtl tr_id augBlech_Links 0.0 0.0 _augenblech_links_)

  (setq augBlech_Rechts (Blech.create))

    ; Wenn das Objekt als Augenblech angefgt wird, werden dp, hp und bp neu gesetzt
    ; Zudem werden die beiden Attribute fr den Schlitz gesetzt:
    ; lSchlitz und dSchlitz. Sollen also andere Werte gelten, dann muss man
    ; diese nach dem addAbtl setzen. (Zumindest momentan)
  (traeger.addabtl tr_id augBlech_Rechts 0.0 0.0 _augenblech_rechts_)

    ; neue Attribute des Blechobjekts: lSchlitz und dSchlitz
  (setq dSchlitz (Blech.get augBlech_Links dSchlitz)) (print dSchlitz)
  (setq lSchlitz (Blech.get augBlech_Links lSchlitz)) (print lSchlitz)

    ; Lochbild erzeugen (im Normalfall ist es bereits fr den Haupttrger erzeugt worden  
  (setq lchbWivb_Links (Lochbild.create))
    ; zum AT hinzufgen
  (traeger.addabtl tr_id lchbWivb_Links 0.0 0.0 _windvblchb_links_)
    ; Lochbilddaten initialisieren (im Normalfall bereits geschehen.
    ; WICHTIG!! dKante ist der Abstand zum Systempunkt. Von da an ist e0
    ; definiert
  (calcAndSetLochbildDaten lchbWivb_Links)
    ; Jetzt noch den Master einstellen, damit in diesem Fall das Lochbild auch erscheint.
  (setq Abtl_WiVbLchb_l (traeger.get Tr_ID ABTeil lchbWivb_Links))
  (Anbauteil.set Abtl_WiVbLchb_l (Master 1))

    ; alles analog zu dem vorherigen
  (setq lchbWivb_Rechts (Lochbild.create))
  (traeger.addabtl tr_id lchbWivb_Rechts 0.0 0.0 _windvblchb_rechts_)
  (calcAndSetLochbildDaten lchbWivb_Rechts)

  (setq Abtl_WiVbLchb_r (traeger.get Tr_ID ABTeil lchbWivb_Rechts))
  (Anbauteil.set Abtl_WiVbLchb_r (Master 1))
  
  (Connect.storeAnschlObjs CastaData augBlech_Links augBlech_Rechts lchbWivb_Links lchbWivb_Rechts)
	
)


(defun calcAndSetLochbildDaten (Lchb_ID)
	(Lochbild.set Lchb_ID 
		(S_Bez   "M16")
		(Guete   "4.6")
		(e       "100 50 0 0 0 0")
		(w       "0  0")
		(Klemml  20)
	)
)







